#INCLUDE "Common.CH"
#INCLUDE "GRA.CH"

#INCLUDE "ot4xb.CH"
#include "WinUser_constants.ch"
#include "WinGdi_constants.ch"

PROCEDURE MAIN
LOCAL aSize := AppDeskTop():CurrentSize()
LOCAL hDC := @user32:GetDC( HWND_DESKTOP )
LOCAL nXLogPixel := @Gdi32:GetDeviceCaps( hDC, LOGPIXELSX )
LOCAL nYLogPixel := @Gdi32:GetDeviceCaps( hDC, LOGPIXELSY )
LOCAL nVERTRES   := @Gdi32:GetDeviceCaps( hDC, VERTRES    )
LOCAL nHORZRES   := @Gdi32:GetDeviceCaps( hDC, HORZRES    )
LOCAL nDHORZRES  := @Gdi32:GetDeviceCaps( hDC, DESKTOPHORZRES )
LOCAL nDVERTRES  := @Gdi32:GetDeviceCaps( hDC, DESKTOPVERTRES )

   @user32:ReleaseDC( HWND_DESKTOP,hDC)

   ? VAR2CHAR(aSize)
   ? "---------------------------"
   ? nXLogPixel, nXLogPixel/72
   ? nYLogPixel, nYLogPixel/72
   ? "---------------------------"
   ? "aDesk/nRES "
   ? nHORZRES,nVERTRES
   ? aSize[1]/nHORZRES
   ? aSize[2]/nVERTRES
   ? "---------------------------"
   ? nDHORZRES, nDVERTRES
   ? nDHORZRES/nHORZRES
   ? nDVERTRES/nVERTRES
   ? "---------------------------"
   ? "Jan",DPIVerhaeltnis()
   ? "---------------------------"
   ? "Wolfgang"
   ? GetTextDPI(1)
   ? GetTextDPI(2)
WAIT
RETURN

FUNCTION DPIVerhaeltnis
LOCAL oPS := NIL
LOCAL aTmp := {}
   oPS := XbpPresSpace():New():Create( AppDesktop():WinDevice(), ;
                                    {100, 100}, ;                                                  // Genau 1x1 Zoll gro
                                    GRA_PU_LOENGLISH)                                              // Eine Einheit ist 0.01 Inch
   aTmp := oPS:SetViewport()
   oPS:Destroy()
RETURN (aTmp[3] - aTmp[1])

FUNCTION GetTextDPI(art)
** Rckgabe bei art=1 dpi, 2=Zoomfaktor
LOCAL oPS, aTmp
DEFAULT art TO 1
   oPS := XbpPresSpace():New():Create( AppDesktop():WinDevice(), ;
                                       {100,100}, GRA_PU_LOENGLISH )
   aTmp:= oPS:SetViewport()
   oPS:Destroy()
RETURN iif(art=1, aTmp[3]-aTmp[1],round((aTmp[3]-aTmp[1])/96,2))